-- (C) Copyright International Business Machines Corporation 23 January
-- 1990.  All Rights Reserved.
--
-- See the file USERAGREEMENT distributed with this software for full
-- terms and conditions of use.
tokenizer:  using(Standard,Tokenizer) process(Init: TokenizeIn)

declare
  Parms: TokenizeInterface; -- callmessage received from parent
begin block
  declare
    blanks :charstring; -- blanks at beginning of token
    pNB:integer; -- position of first non-blank
    pB: integer; -- position of first blank after token, else EOS
  begin
    receive Parms from Init;
    pNB := position of C in parms.string where(C <> ' ');
    extract blanks from B in parms.string where(position of B < pNB);
    block begin
      pB := position of B in parms.string where(B = ' ');
    on (NotFound)
      pB := size of parms.string;
    end block;
    extract parms.token from C in
      parms.string where(position of C < pB);
    return Parms;
  on (NotFound)
    return Parms exception NoToken;
  end block;
  
  end process
